#!/bin/bash

##############################################################################
# Vars setzen                          #######################################
##############################################################################

DISTRO="null";

DOVECOT_SOURCES="http://dovecot.org/releases/2.0/dovecot-2.0.16.tar.gz";
DOVECOT_FILE="dovecot-2.0.16"; # ohne .tar.gz
DOVECOT_VERSION="2.0.16";

DOVECOT_SIEVE_SOURCES="http://www.rename-it.nl/dovecot/2.0/dovecot-2.0-pigeonhole-0.2.5.tar.gz";
DOVECOT_SIEVE_FILE="dovecot-2.0-pigeonhole-0.2.5"; # ohne .tar.gz
DOVECOT_SIEVE_VERSION="0.2.5";

DOVECOT_CONFIG_SOURCE="http://blogfiles.ka-mediendesign.de/dovecot_config.zip"
DOVECOT_STARTSCRIPT_SOURCE="http://blogfiles.ka-mediendesign.de/dovecot_start.zip"

ROUNDCUBE_SOURCES="http://sourceforge.net/projects/roundcubemail/files/roundcubemail/0.5.1/roundcubemail-0.5.1.tar.gz"
ROUNDCUBE_FILE="roundcubemail-0.5.1"
ROUNDCUBE_VERSION="0.5.1";

ROUNDCUBE_SAUSERPREFS_SOURCE="http://blogfiles.ka-mediendesign.de/sauserprefs.zip"
ROUNDCUBE_SAUSERPREFS_FILE="sauserprefs"
ROUNDCUBE_SAUSERPREFS_VERSION="1.6";

APACHECONFIG_SOURCE="http://blogfiles.ka-mediendesign.de/vhost_example.zip"
APACHECONFIG_FILE="vhost_example"

PLESKMOD_MAILCHECK_SOURCE="http://blogfiles.ka-mediendesign.de/PleskMailCheck.pl.zip"
PLESKMOD_MAILCHECK_FILE="PleskMailCheck.pl"



#############################################################################################################################
#############################################################################################################################
####################################### AB HIER MENU DER PLESK MOD ##########################################################
#############################################################################################################################
#############################################################################################################################



##############################################################################
# Starthinweis                         #######################################
##############################################################################

while :
do
    clear
    echo " "
    echo " "
    echo " "
    echo "      PleskMod Autoinstaller"
    echo "      ------------------------------------"
    echo " "
    echo "      Security: Backup your system"
    echo "      before running this installer!"
    echo " "
    echo "      Before you run this installer make"
    echo "      sure that all your packages are up"
    echo "      to date. Use the apt-get command"
    echo "      for checking and upgrading this."
    echo " "
    echo "      This modification comes with"
    echo "      absolutely NO WARRANTY."
    echo " "
    echo "      1. Okay, let's go!"
    echo " "
    echo "      9. Exit"
    echo " "
    echo " "
    echo -n "      Please choose an option and press [enter]: "
    read opt
    case $opt in
        1)  clear
            break;;
            
        9)  clear
            exit 1;;
        
        *)  echo " "
            echo " "
            echo "      Please choose a valid option."
            echo -n "      Press [enter] key to continue ..."
            read enterKey;;
    esac
done


##############################################################################
# Distribution waehlen                 #######################################
##############################################################################

while :
do
    clear
    echo " "
    echo " "
    echo " "
    echo "      PleskMod Autoinstaller"
    echo "      ------------------------------------"
    echo " "
    echo "      Choose your distribution"
    echo " "
    echo "      1. Debian"
    echo "      2. Ubuntu"
    echo "      3. CentOS"
    echo "      4. SuSe"
    echo " "
    echo "      9. Exit"
    echo " "
    echo " "
    echo -n "      Please choose an option and press [enter]: "
    read opt
    case $opt in
        1)  DISTRO="Debian"
            break;;
        
        2)  DISTRO="Ubuntu"
            break;;
        
        3)  DISTRO="CentOS"
            break;;
    
        4)  DISTRO="SuSe"
            break;;
            
        9)  clear
            exit 1;;
        
        *)  echo " "
            echo " "
            echo "      Please choose a valid option."
            echo -n "      Press [enter] key to continue ..."
            read enterKey;;
    esac
done


##############################################################################
# Optionen selektieren                 #######################################
##############################################################################

CLAMAVSA=" ";
DOVECOT=" ";
ROUNDCUBE=" ";

while :
do
    clear
    echo " "
    echo " "
    echo " "
    echo "      PleskMod Autoinstaller for $DISTRO"
    echo "      ------------------------------------"
    echo " "
    echo "      Choose your options to install"
    echo " "
    echo "      1. [$DOVECOT] Dovecot (v$DOVECOT_VERSION) with Sieve (v$DOVECOT_SIEVE_VERSION)"
    echo "      2. [$CLAMAVSA] ClamAV / ClamSMTP and SpamAssassin"
    echo "      3. [$ROUNDCUBE] RoundCube (v$ROUNDCUBE_VERSION)"
    echo " "
    echo "      4. Next"
    echo " "
    echo "      9. Exit"
    echo " "
    echo " "
    echo -n "      Please choose an option and press [enter]: "
    read opt
    case $opt in
        1)  if [ "$DOVECOT" = " " ]
                then DOVECOT="*"
                else DOVECOT=" "
            fi;;
            
        2)  if [ "$CLAMAVSA" = " " ]
                then CLAMAVSA="*"
                else CLAMAVSA=" "
            fi;;
        
        3)  if [ "$ROUNDCUBE" = " " ]
                then ROUNDCUBE="*"
                else ROUNDCUBE=" "
            fi;;
        
        4)  break;;
            
        9)  clear
            exit 1;;
        
        *)  echo " "
            echo " "
            echo "      Please choose a valid option."
            echo -n "      Press [enter] key to continue ..."
            read enterKey;;
    esac
done



##############################################################################
# Bestaetigung                         #######################################
##############################################################################

if [ "$CLAMAVSA" = "*" ] 
then
    CLAMAVSA_INSTALL="TRUE"
    CLAMAVSA_CONFIRM="Install"
    CLAMAVSA_SKIP="FALSE"
else
    CLAMAVSA_INSTALL="FALSE"
    CLAMAVSA_CONFIRM="Do not install"
    CLAMAVSA_SKIP="FALSE"
fi

if [ "$DOVECOT" = "*" ] 
then
    DOVECOT_INSTALL="TRUE"
    DOVECOT_CONFIRM="Install"
else
    DOVECOT_INSTALL="FALSE"
    DOVECOT_CONFIRM="Do not install"
fi

if [ "$ROUNDCUBE" = "*" ] 
then
    ROUNDCUBE_INSTALL="TRUE"
    ROUNDCUBE_CONFIRM="Install"
    ROUNDCUBE_SKIP="FALSE"
else
    ROUNDCUBE_INSTALL="FALSE"
    ROUNDCUBE_CONFIRM="Do not install"
    ROUNDCUBE_SKIP="FALSE"
fi
while :
do
    clear
    echo " "
    echo " "
    echo " "
    echo "      PleskMod Autoinstaller for $DISTRO"
    echo "      ------------------------------------"
    echo " "
    echo "      Your selection"
    echo " "
    echo "      Distribution . . . . .  $DISTRO"
    echo "      Dovecot width Sieve. .  $DOVECOT_CONFIRM"
    echo "      ClamAV / SpamAssassin   $CLAMAVSA_CONFIRM"
    echo "      RoundCube. . . . . . .  $ROUNDCUBE_CONFIRM"
    echo " "
    echo "      9. Exit"
    echo " "
    echo " "
    echo -n "      For confirmation please press [enter]: "
    read opt
    case $opt in
        9)  clear
            exit 1;;
    
        *)  break
            clear;;
    esac
done





#############################################################################################################################
#############################################################################################################################
####################################### AB HIER INSTALLATION DER PLESK MOD ##################################################
#############################################################################################################################
#############################################################################################################################



##############################################################################
# Install starten und weitere Vars setzen ####################################
##############################################################################

ADMINPW=$(cat /etc/psa/.psa.shadow);

# $DISTRO               = Debian/CentOS/SuSe
# $CLAMAVSA_INSTALL     = TRUE/FALSE
# $DOVECOT_INSTALL      = TRUE/FALSE
# $ROUNDCUBE_INSTALL    = TRUE/FALSE
clear
echo " "
echo " "
echo "      PleskMod Autoinstaller for $DISTRO"
echo "      ------------------------------------------"
echo " "



##############################################################################
# Checking System                      #######################################
##############################################################################

echo "         System"
echo " " 

#
# Spamassassin Plesk Check
# 
if [ "$CLAMAVSA_INSTALL" = "TRUE" ]
then
    echo -n "      Checking for Plesk SpamAssassin      " 
    if test -f /etc/init.d/psa-spamassassin &> /dev/null;
    then
        echo "stop!"
        echo " "
        echo "      SpamAssassin is already installed via Plesk."
        echo "      Unselecting packages ClamAV and SpamAssassin"
        echo "      and continue..."
        echo " "
        CLAMAVSA_INSTALL="FALSE"
        CLAMAVSA_SKIP="TRUE"
    else
        echo "done!"
    fi
fi


#
# RoundCube Check
# 
if [ "$ROUNDCUBE_INSTALL" = "TRUE" ]
then
    echo -n "      Checking for RoundCube               " 
    if test -f /var/www/roundcube/config/db.inc.php &> /dev/null;
    then
        echo "stop!"
        echo " "
        echo "      RoundCube is already installed."
        echo "      Unselecting package roundcube and"
        echo "      continue..."
        echo " "
        ROUNDCUBE_INSTALL="FALSE"
        ROUNDCUBE_SKIP="TRUE"
    else
        echo "done!"
    fi
fi


echo -n "      Checking for Postfix                 "  
#
# Postfix Check
# 
if test ! -f /etc/init.d/postfix &> /dev/null;
then
    echo "stop!"
    echo " "
    echo "      Postfix is not installed."
    echo "      For this modification postfix is required."
    echo "      Switch your Plesk installation from qmail"
    echo "      to postfix and run this installer again."
    echo " "
    echo "      Bye..."
    echo " "
    echo " "
    exit
else
    echo "done!"
fi

#
# Configs Vars erstellen
#
POSTFIX_CONFIG_MASTER_INPUT=""
POSTFIX_CONFIG_MAIN_INPUT=""
SA_CONFIG_INPUT=""

##############################################################################
# APT Update                           #######################################
##############################################################################

echo -n "      Updating Aptitude                    "   
apt-get update &> /dev/null
echo "done!"

echo -n "      Upgrading Aptitude                   "   
apt-get --assume-yes install &> /dev/null

sleep 1

apt-get --assume-yes upgrade &> /dev/null
echo "done!"

sleep 1



##############################################################################
# ClamAV  und SpamAssassin installieren und einrichten   #####################
##############################################################################

echo " "
echo " "
echo "         ClamAV / ClamSMTP"
echo " "
    
if [ "$CLAMAVSA_INSTALL" = "TRUE" ]
then

    echo -n "      Installing ClamAV                    "   
    apt-get --assume-yes install clamav &> /dev/null
    echo "done!"
           
    sleep 1
                 
    echo -n "      Installing ClamSMTP                  "   
    apt-get --assume-yes install clamsmtp &> /dev/null
    echo "done!"
           
    sleep 1
         
    echo -n "      Creating ClamSMTP Config             "  
    # ClamSMTP Port setzen auf 10029
    sed -i 's/OutAddress: \([0-9]\{1,5\}\)/OutAddress: 6001/g' /etc/clamsmtpd.conf;
    sleep 1
    sed -i 's/Listen: \(\([0-9]\{1,3\}\)\.\)\{3\}\([0-9]\{1,3\}\)\:\([0-9]\{1,5\}\)/Listen: 127.0.0.1:10029/g' /etc/clamsmtpd.conf;
    sleep 1
    
    # ClamAV Postfix Config (master.cf)
    sed -i 's/smtpd_proxy_filter=\(\([0-9]\{1,3\}\)\.\)\{3\}\([0-9]\{1,3\}\)\:\([0-9]\{1,5\}\)/smtpd_proxy_filter=127.0.0.1:10029/g' /etc/postfix/master.cf;
    
    sleep 1
    
    POSTFIX_CONFIG_MASTER_INPUT="${POSTFIX_CONFIG_MASTER_INPUT}
scan              unix  -   -   n   -   16 smtp -o smtp_send_xforward_command=yes
127.0.0.1:6001    inet  n   -   n   -   16 smtpd
        -o content_filter=spamchk
        -o receive_override_options=no_unknown_recipient_checks,no_header_body_checks
        -o smtpd_helo_restrictions=
        -o smtpd_client_restrictions=
        -o smtpd_sender_restrictions=
        -o smtpd_recipient_restrictions=permit_mynetworks,reject
        -o mynetworks_style=host
        -o smtpd_authorized_xforward_hosts=127.0.0.0/8"
    
    sleep 1

    # ClamAV Postfix Config anhaengen (main.cf)
    
    POSTFIX_CONFIG_MAIN_INPUT="${POSTFIX_CONFIG_MAIN_INPUT}
content_filter = scan:127.0.0.1:10029
receive_override_options = no_address_mappings"
    
    echo "done!"
    
    sleep 1
    
    echo -n "      Adding ClamAV to autostart           "  
    update-rc.d clamav-daemon defaults &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Adding ClamSMTP to autostart         "  
    update-rc.d clamsmtp defaults &> /dev/null
    echo "done!"
           
    sleep 1
        
    echo -n "      Stopping ClamAV                      "  
    /etc/init.d/clamav-daemon stop &> /dev/null
    echo "done!"
           
    sleep 1
        
    echo -n "      Starting ClamAV                      "  
    /etc/init.d/clamav-daemon start &> /dev/null
    echo "done!"
           
    sleep 1
        
    echo -n "      Stopping ClamSMTP                    "  
    /etc/init.d/clamsmtp stop &> /dev/null
    echo "done!"
           
    sleep 1
        
    echo -n "      Starting ClamSMTP                    "  
    /etc/init.d/clamsmtp start &> /dev/null
    echo "done!"
           
    sleep 1

    
    #
    # SpamAssassin
    #
    
    echo " "
    echo " "
    echo "         SpamAssassin"
    echo " "

    echo -n "      Installing SpammAssassin             "   
    apt-get --assume-yes install spamassassin &> /dev/null
    echo "done!"
           
    sleep 1
         
    echo -n "      Installing Spamc                     "   
    apt-get --assume-yes install spamc &> /dev/null
    echo "done!"
           
    sleep 1
         
    echo -n "      Creating SpamAssassin Config         "  
    # SpamAssassin aktivieren
    sed -i 's/ENABLED=[0-1]/ENABLED=1/g' /etc/default/spamassassin;
    sleep 1
        
    # SpamAssassin Startoptionen setzen
    sed -i 's/OPTIONS=".*"/OPTIONS="-u vmail --create-prefs --max-children 5 --sql-config --helper-home-dir"/g' /etc/default/spamassassin;
    sleep 1
        
    if [ "$ROUNDCUBE_INSTALL" = "TRUE" ] || [ "$ROUNDCUBE_SKIP" = "TRUE" ]
    then
        # SpamAssassin MySQL Config
        
        SA_CONFIG_INPUT="${SA_CONFIG_INPUT}
user_scores_dsn DBI:mysql:roundcubemail:localhost
user_scores_sql_username admin
user_scores_sql_password $ADMINPW
user_scores_sql_custom_query SELECT preference, value FROM spamassassin WHERE (username = _USERNAME_ OR username = '@GLOBAL') ORDER BY username ASC"

        sleep 1
    fi
    
    # SpamAssassin Postfix Config (master.cf)
    sed -i 's/#127\.0\.0\.1\:10025 inet/127\.0\.0\.1\:10025 inet/g' /etc/postfix/master.cf;
    sleep 1
    sed -i 's/#127\.0\.0\.1\:10026 inet/127\.0\.0\.1\:10026 inet/g' /etc/postfix/master.cf;
    sleep 1
    sed -i 's/#127\.0\.0\.1\:10027 inet/127\.0\.0\.1\:10027 inet/g' /etc/postfix/master.cf;
    sleep 1
    sed -i 's/127\.0\.0\.1\:10025 inet/#127\.0\.0\.1\:10025 inet/g' /etc/postfix/master.cf;
    sleep 1
    sed -i 's/127\.0\.0\.1\:10026 inet/#127\.0\.0\.1\:10026 inet/g' /etc/postfix/master.cf;
    sleep 1
    sed -i 's/127\.0\.0\.1\:10027 inet/#127\.0\.0\.1\:10027 inet/g' /etc/postfix/master.cf;
    sleep 1
    
    sed -i 's/pickup fifo n \- \- 60 1 pickup \-o content_filter\=smtp\:127\.0\.0\.1\:10027/pickup    fifo  n       -       n       60      1       pickup -o content_filter=/g' /etc/postfix/master.cf;
    
    sleep 1
    
    POSTFIX_CONFIG_MASTER_INPUT="${POSTFIX_CONFIG_MASTER_INPUT}
spamchk           unix  -   n   n   -   10 pipe flags=Rq user=vmail argv=/var/vmail/spamchk -f \${sender} -- \${recipient}"
    
    sleep 1
        
    # SA Postfix Config anhaengen (main.cf)
    POSTFIX_CONFIG_MAIN_INPUT="${POSTFIX_CONFIG_MAIN_INPUT}
spamchk_destination_recipient_limit = 1"

    echo "done!"
           
    sleep 1
         
    echo -n "      Adding SpamAssassin to autostart     "  
    update-rc.d spamassassin defaults &> /dev/null
    echo "done!"
    
    sleep 1
         
    echo -n "      Creating user 'vmail'                "  
    useradd vmail &> /dev/null
    echo "done!"
           
    sleep 1    
        
    echo -n "      Creating spamchk file                "  
    # SpamAssassin spamchk File erstellen
    SPAMCHK_FILE="#!/bin/sh
# -----------------------------------------------------------------
# File:        spamchk
# Purpose:     SPAMASSASIN shell-based filter
# Location:    /usr/local/bin
# Usage:       Call this script from master.cf (Postfix)
# Certified:   GENTOO Linux, Spamassassin 3.0, Postfix
# -----------------------------------------------------------------

# Variables
SENDMAIL=\"/usr/sbin/sendmail -i\"
EGREP=/bin/egrep

# Exit codes from
EX_UNAVAILABLE=69

# Clean up when done or when aborting.
trap \"rm -f /var/tempfs/out.\$\$\" 0 1 2 3 15

# Pipe message to spamc
cat | /usr/bin/spamc -s 1024000 -u \$4 > /var/tempfs/out.\$\$

\$SENDMAIL \"\$@\" < /var/tempfs/out.\$\$

# Postfix returns the exit status of the Postfix sendmail command.
exit $?"
    mkdir /var/vmail/ &> /dev/null
    sleep 1
    mkdir /var/tempfs/ &> /dev/null
    sleep 1
    touch /var/vmail/spamchk &> /dev/null
    sleep 1
    echo "$SPAMCHK_FILE" > /var/vmail/spamchk
    sleep 1
    chmod 755 /var/vmail &> /dev/null
    sleep 1
    chown vmail:vmail /var/vmail &> /dev/null
    sleep 1
    chmod 755 /var/vmail/spamchk &> /dev/null
    sleep 1
    chown vmail:vmail /var/vmail/spamchk &> /dev/null
    sleep 1
    chmod 755 /var/tempfs &> /dev/null
    sleep 1
    chown vmail:vmail /var/tempfs &> /dev/null
    echo "done!"
           
    sleep 1      
        
    echo -n "      Stopping SpamAssassin                "  
    /etc/init.d/spamassassin stop &> /dev/null
    echo "done!"
           
    sleep 1
        
    echo -n "      Starting SpamAssassin                "  
    /etc/init.d/spamassassin start &> /dev/null
    echo "done!"
           
    sleep 1
else
    if [ "$CLAMAVSA_SKIP" = "FALSE" ]
    then
        echo -n "      Deactivating ClamAV/SA if necessary  "
    
        sed -i 's/#127\.0\.0\.1\:10025 inet/127\.0\.0\.1\:10025 inet/g' /etc/postfix/master.cf;
        sleep 1
        sed -i 's/#127\.0\.0\.1\:10026 inet/127\.0\.0\.1\:10026 inet/g' /etc/postfix/master.cf;
        sleep 1
        sed -i 's/#127\.0\.0\.1\:10027 inet/127\.0\.0\.1\:10027 inet/g' /etc/postfix/master.cf;
        sleep 1 
        sed -i 's/pickup    fifo  n       \-       n       60      1       pickup \-o content_filter\=/pickup fifo n - - 60 1 pickup -o content_filter=smtp:127.0.0.1:10027/g' /etc/postfix/master.cf;
        sleep 1
        sed -i 's/smtpd_proxy_filter\=127\.0\.0\.1\:10029/smtpd_proxy_filter=127.0.0.1:10025/g' /etc/postfix/master.cf;
        sleep 1   
        update-rc.d -f spamassassin remove &> /dev/null
        sleep 1   
        update-rc.d -f clamav-daemon remove &> /dev/null
        sleep 1   
        update-rc.d -f clamsmtp remove &> /dev/null
        sleep 1   
        etc/init.d/spamassassin stop &> /dev/null
        sleep 1   
        etc/init.d/clamsmtp stop &> /dev/null
        sleep 1   
        etc/init.d/clamav-daemon stop &> /dev/null
        sleep 1   
        
        echo "done!"
    fi
fi



##############################################################################
# Dovecot Installation                            ############################
##############################################################################
echo " "
echo " "
echo "         Dovecot with Sieve"
echo " "
    
if [ "$DOVECOT_INSTALL" = "TRUE" ]
then
    echo -n "      Downloading Dovecot Sources          "  
    mkdir -p /root/pleskmod/dovecot
    cd /root/pleskmod/dovecot
    wget $DOVECOT_SOURCES &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Downloading Sieve Sources            "  
    mkdir -p /root/pleskmod/dovecot_sieve
    cd /root/pleskmod/dovecot_sieve
    wget $DOVECOT_SIEVE_SOURCES &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Unpacking Dovecot Sources            "  
    cd /root/pleskmod/dovecot
    tar xfvs ${DOVECOT_FILE}.tar.gz &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Unpacking Sieve Sources              "  
    cd /root/pleskmod/dovecot_sieve
    tar xfvs ${DOVECOT_SIEVE_FILE}.tar.gz &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Compiling Dovecot (takes a while)    "  
    cd /root/pleskmod/dovecot/${DOVECOT_FILE}
    apt-get --assume-yes install libssl-dev &> /dev/null
    apt-get --assume-yes install libmysqlclient-dev &> /dev/null
    ./configure --with-ssl=openssl --with-sql --with-mysql &> /dev/null
    make &> /dev/null
    make install &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Compiling Sieve (takes a while)      "  
    cd /root/pleskmod/dovecot_sieve/${DOVECOT_SIEVE_FILE}
    ./configure --with-dovecot=/usr/local/lib/dovecot &> /dev/null
    make &> /dev/null
    make install &> /dev/null
    echo "done!"
           
    sleep 1

    echo -n "      Configure Dovecot                    "  
    if test -f /usr/local/etc/dovecot/dovecot.conf;
    then
        echo "skipped! (already exists)"
    else
        cd /usr/local/etc/dovecot
        wget $DOVECOT_CONFIG_SOURCE &> /dev/null
        unzip -o dovecot_config.zip &> /dev/null
        rm dovecot_config.zip &> /dev/null
        sed -i 's/dbname=psa user=admin password=.*/dbname=psa user=admin password='$ADMINPW'/g' /usr/local/etc/dovecot/dovecot-sql.conf.ext
        echo "done!"
           
        sleep 1
    fi    
    
    echo -n "      Creating user 'dovenull'             "  
    useradd dovenull &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Creating user 'dovecot'              "  
    useradd dovecot &> /dev/null
    echo "done!"
           
    sleep 1

    echo -n "      Stopping Courier                     "  
    killall couriertls &> /dev/null
    killall couriertcpd &> /dev/null
    killall courierlogger &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Deactivating Courier                 "  
    mv /etc/init.d/courier-imap /etc/init.d/courier-imap.bkp &> /dev/null
    echo "done!"
           
    sleep 1

    echo -n "      Starting Dovecot                     "  
    cd /etc/init.d
    wget $DOVECOT_STARTSCRIPT_SOURCE &> /dev/null
    sleep 1
    unzip -o dovecot_start.zip &> /dev/null
    sleep 1
    rm dovecot_start.zip &> /dev/null
    sleep 1
    /etc/init.d/dovecot start &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Adding Dovecot to autostart          "  
    update-rc.d dovecot defaults &> /dev/null
    echo "done!"
           
    sleep 1

    echo -n "      Creating Postfix Config              "  
    
    # Dovecot Postfix Config anhaengen (main.cf)
    POSTFIX_CONFIG_MAIN_INPUT="${POSTFIX_CONFIG_MAIN_INPUT}
virtual_alias_maps = hash:/etc/postfix/virtual_aliases_dynamic, \$virtual_maps, hash:/var/spool/postfix/plesk/virtual, hash:/etc/postfix/virtual_aliases
virtual_transport = dovecot
dovecot_destination_recipient_limit = 1
mailbox_command = /usr/local/libexec/dovecot/deliver"
    
    sleep 1
    
    POSTFIX_CONFIG_MASTER_INPUT="${POSTFIX_CONFIG_MASTER_INPUT}
dovecot           unix  -   n   n   -   -  pipe flags=DRhu user=popuser argv=/usr/local/libexec/dovecot/deliver -d \${recipient}"
    
    sleep 1
    
    if test ! -f /etc/postfix/virtual_aliases_dynamic;
    then
        touch /etc/postfix/virtual_aliases_dynamic &> /dev/null
        postmap /etc/postfix/virtual_aliases_dynamic
        sleep 1
    fi
    
    if test ! -f /etc/postfix/virtual_aliases;
    then
        touch /etc/postfix/virtual_aliases &> /dev/null
        postmap /etc/postfix/virtual_aliases
        sleep 1
    fi
    
    if test ! -f /var/log/dovecot-sieve.log;
    then
        touch /var/log/dovecot-sieve.log &> /dev/null
        chmod 777 /var/log/dovecot-sieve.log
        sleep 1
    else
        chmod 777 /var/log/dovecot-sieve.log
        sleep 1
    fi
    
    if test ! -f /var/log/dovecot-debug.log;
    then
        touch /var/log/dovecot-debug.log &> /dev/null
        chmod 777 /var/log/dovecot-debug.log
        sleep 1
    else
        chmod 777 /var/log/dovecot-debug.log
        sleep 1
    fi
    echo "done!"
           
    sleep 1
    
    echo -n "      Reloading Postfix Config             "  
    /etc/init.d/postfix reload &> /dev/null
    echo "done!"
           
    sleep 1

    echo -n "      Downloading PleskMod MailCheck       "  
    mkdir /root/pleskmod/mailcheckscript
    cd /root/pleskmod/mailcheckscript
    wget $PLESKMOD_MAILCHECK_SOURCE &> /dev/null
    unzip ${PLESKMOD_MAILCHECK_FILE}.zip &> /dev/null
    cp /root/pleskmod/mailcheckscript/PleskMailCheck.pl /var/vmail/
    chown root:root /var/vmail/PleskMailCheck.pl
    chmod 744 /var/vmail/PleskMailCheck.pl
    echo "done!"
           
    sleep 1

    echo -n "      Seting Cronjob on MailCheck          " 
    crontab -l > cron.txt
    CONJOB=$(cat cron.txt)
    CONJOB="${CONJOB}

##Plesk MailForwarder aktualisieren
*/2	*	*	*	*	/var/vmail/PleskMailCheck.pl &> /dev/null" 
    echo "$CONJOB" > cron.txt
    crontab cron.txt
    echo "done!"
           
    sleep 1
    

    echo -n "      Removing temp files                  "  
    rm -r /root/pleskmod &> /dev/null
    echo "done!"
           
    sleep 1
    
else
    echo -n "      Deactivating Dovecot if necessary    "  
    mv /etc/init.d/courier-imap.bkp /etc/init.d/courier-imap &> /dev/null
    sleep 1
    update-rc.d -f dovecot remove &> /dev/null
    sleep 1
    /etc/init.d/dovecot stop &> /dev/null
    sleep 1
    /etc/init.d/courier-imap start &> /dev/null
    echo "done!"
    
    sleep 1
fi


    


##############################################################################
# Config erstellen                     #######################################
##############################################################################

echo " "
echo " "
echo "         Editing Config files"
echo " "


echo -n "      Postfix (master.cf)                  "  
sed -i -n '1h;1!H;${;g;s/\n## Start PleskMod Config ##.*## End PleskMod Config ##//g;p;}' /etc/postfix/master.cf;
sleep 1
POSTFIX_CONFIG_MASTER_INPUT="
## Start PleskMod Config ##${POSTFIX_CONFIG_MASTER_INPUT}
## End PleskMod Config ##"
POSTFIX_CONFIG_MASTER=$(cat /etc/postfix/master.cf)
POSTFIX_CONFIG_MASTER="${POSTFIX_CONFIG_MASTER} ${POSTFIX_CONFIG_MASTER_INPUT}"    
echo "$POSTFIX_CONFIG_MASTER" > /etc/postfix/master.cf
echo "done!"
sleep 1


echo -n "      Postfix (main.cf)                    "  
sed -i -n '1h;1!H;${;g;s/\n## Start PleskMod Config ##.*## End PleskMod Config ##//g;p;}' /etc/postfix/main.cf;  
sleep 1
POSTFIX_CONFIG_MAIN_INPUT="
## Start PleskMod Config ##${POSTFIX_CONFIG_MAIN_INPUT}
## End PleskMod Config ##"
POSTFIX_CONFIG_MAIN=$(cat /etc/postfix/main.cf)
POSTFIX_CONFIG_MAIN="${POSTFIX_CONFIG_MAIN} ${POSTFIX_CONFIG_MAIN_INPUT}"    
echo "$POSTFIX_CONFIG_MAIN" > /etc/postfix/main.cf
echo "done!"
sleep 1


echo -n "      Postfix restart                      "  
/etc/init.d/postfix restart &> /dev/null
echo "done!"
sleep 1

if [ "$CLAMAVSA_INSTALL" = "TRUE" ]
then
    echo -n "      SpamAssassin (local.cf)              "  
    sed -i -n '1h;1!H;${;g;s/\n## Start PleskMod Config ##.*## End PleskMod Config ##//g;p;}' /etc/spamassassin/local.cf;   
    sleep 1
    SA_CONFIG_INPUT="
## Start PleskMod Config ##${SA_CONFIG_INPUT}
## End PleskMod Config ##"
    SA_CONFIG=$(cat /etc/spamassassin/local.cf)
    SA_CONFIG="${SA_CONFIG} ${SA_CONFIG_INPUT}"    
    echo "$SA_CONFIG" > /etc/spamassassin/local.cf
    echo "done!"
    sleep 1
    
    
    echo -n "      SpamAssassin restart                 "  
    /etc/init.d/spamassassin restart &> /dev/null
    echo "done!"
    sleep 1
fi



##############################################################################
# RoundCube Installation                          ############################
##############################################################################
echo " "
echo " "
echo "         RoundCube"
echo " "
    
if [ "$ROUNDCUBE_INSTALL" = "TRUE" ]
then
    echo -n "      Downloading Roundcube Sources        "  
    mkdir -p /root/pleskmod/roundcube
    cd /root/pleskmod/roundcube
    wget $ROUNDCUBE_SOURCES &> /dev/null
    sleep 1
    wget $APACHECONFIG_SOURCE &> /dev/null
    if [ "$CLAMAVSA_INSTALL" = "TRUE" ]
    then
        sleep 1
        wget $ROUNDCUBE_SAUSERPREFS_SOURCE &> /dev/null
    fi
    echo "done!"
           
    sleep 1
    
    echo -n "      Unpacking Roundcube Sources          "  
    cd /root/pleskmod/roundcube
    tar xfvs ${ROUNDCUBE_FILE}.tar.gz &> /dev/null
    sleep 1
    unzip ${APACHECONFIG_FILE}.zip &> /dev/null
    if [ "$CLAMAVSA_INSTALL" = "TRUE" ]
    then
        sleep 1
        unzip ${ROUNDCUBE_SAUSERPREFS_FILE}.zip &> /dev/null
    fi
    echo "done!"
           
    sleep 1
    
    echo -n "      Moving Roundcube to /var/www         "  
    mkdir /var/www/roundcube &> /dev/null
    cp -R /root/pleskmod/roundcube/${ROUNDCUBE_FILE}/* /var/www/roundcube &> /dev/null
    sleep 1
    cp -R /root/pleskmod/roundcube/${APACHECONFIG_FILE} /var/www/roundcube &> /dev/null
    if [ "$CLAMAVSA_INSTALL" = "TRUE" ]
    then
        sleep 1
        cp -R /root/pleskmod/roundcube/${ROUNDCUBE_SAUSERPREFS_FILE} /var/www/roundcube/plugins &> /dev/null
    fi
    sleep 1
    rm -R /root/pleskmod
    echo "done!"
           
    sleep 1
    
    echo -n "      Creating database                    "  
    mysql -f --user "admin" --password="${ADMINPW}" roundcubemail < /var/www/roundcube/SQL/mysql.initial.sql &> /dev/null
    echo "done!"
           
    sleep 1
    
    echo -n "      Configure RoundCube                  "  
    cp /var/www/roundcube/config/db.inc.php.dist /var/www/roundcube/config/db.inc.php &> /dev/null
    sleep 1
    sed -i 's/mysql\:\/\/roundcube\:pass\@localhost\/roundcubemail/mysql\:\/\/admin:'$ADMINPW'\@localhost\/roundcubemail/g' /var/www/roundcube/config/db.inc.php
    sleep 1
    cp /var/www/roundcube/config/main.inc.php.dist /var/www/roundcube/config/main.inc.php &> /dev/null
    sleep 1
    cp /var/www/roundcube/plugins/managesieve/config.inc.php.dist /var/www/roundcube/plugins/managesieve/config.inc.php &> /dev/null
    sleep 1
    sed -i "s/\$rcmail_config\['managesieve_port'\] = [0-9]\{1,5\};/\$rcmail_config\['managesieve_port'\] = 4190;/g" /var/www/roundcube/plugins/managesieve/config.inc.php
        
    if [ "$CLAMAVSA_INSTALL" = "TRUE" ]
    then
        sleep 1
        sed -i "s/\$rcmail_config\['plugins'\] = array();/\$rcmail_config\['plugins'\] = array('sauserprefs', 'managesieve');/g" /var/www/roundcube/config/main.inc.php
        sleep 1
        mysql -f --user "admin" --password="${ADMINPW}" roundcubemail < /var/www/roundcube/plugins/sauserprefs/mysql.initial.sql &> /dev/null
        sleep 1
        sed -i 's/mysql\:\/\/username\:password\@localhost\/database/mysql\:\/\/admin:'$ADMINPW'\@localhost\/roundcubemail/g' /var/www/roundcube/plugins/sauserprefs/config.inc.php
    else
        sleep 1
        sed -i "s/\$rcmail_config\['plugins'\] = array();/\$rcmail_config\['plugins'\] = array('managesieve');/g" /var/www/roundcube/config/main.inc.php
    fi
    
    echo "done!"
           
    echo " "
    echo " "
    echo "      Now you have to configure a vhost file"
    echo "      for RoundCube. Example vhost files are"
    echo "      available at /var/www/roundcube/vhost_exmaple."
    echo "      Read the Readme for further instructions."
fi
    
    
    
##############################################################################
# Fertig                               #######################################
##############################################################################

echo " "
echo " "
echo "      +-------------------------------------+"
echo "      |                                     |"
echo "      |  PleskMod installation successful.  |"
echo "      |                                     |"
echo "      +-------------------------------------+"
echo " "
echo " "


